﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamDockManagerWithWeb.DataSource
{
    public class Data : INotifyPropertyChanged
    {
        private int _intData;
        private int? _nullableIntData;
        private double _doubleData;
        private double? _nullableDoubleData;
        private bool _boolData;
        private bool? _nullableBoolData;
        private string _stringData;
        private DateTime _dateTimeData;
        private DateTime? _nullableDateTimeData;
        private Uri _uriData;
        private ObservableCollection<Data> _dataItems;

        public Data()
        {
        }

        public Data(
            int _intData,
            int? _nullableIntData,
            double _doubleData,
            double? _nullableDoubleData,
            bool _boolData,
            bool? _nullableBoolData,
            string _stringData,
            DateTime _dateTimeData,
            DateTime? _nullableDateTimeData,
            Uri _uriData,
            ObservableCollection<Data> _dataItems)
        {
            this._intData = _intData;
            this._nullableIntData = _nullableIntData;
            this._doubleData = _doubleData;
            this._nullableDoubleData = _nullableDoubleData;
            this._boolData = _boolData;
            this._nullableBoolData = _nullableBoolData;
            this._stringData = _stringData;
            this._dateTimeData = _dateTimeData;
            this._nullableDateTimeData = _nullableDateTimeData;
            this._uriData = _uriData;
            this._dataItems = _dataItems;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public int Int
        {
            get
            {
                return this._intData;
            }

            set
            {
                this._intData = value;
                this.NotifyPropertyChanged("Int");
            }
        }

        public int? NInt
        {
            get
            {
                return this._nullableIntData;
            }

            set
            {
                this._nullableIntData = value;
                this.NotifyPropertyChanged("NInt");
            }
        }

        public double Double
        {
            get
            {
                return this._doubleData;
            }

            set
            {
                this._doubleData = value;
                this.NotifyPropertyChanged("Double");
            }
        }

        public double? NDouble
        {
            get
            {
                return this._nullableDoubleData;
            }

            set
            {
                this._nullableDoubleData = value;
                this.NotifyPropertyChanged("NDouble");
            }
        }

        public bool Bool
        {
            get
            {
                return this._boolData;
            }

            set
            {
                this._boolData = value;
                this.NotifyPropertyChanged("Bool");
            }
        }

        public bool? NBool
        {
            get
            {
                return this._nullableBoolData;
            }

            set
            {
                this._nullableBoolData = value;
                this.NotifyPropertyChanged("NBool");
            }
        }

        public string String
        {
            get
            {
                return this._stringData;
            }

            set
            {
                this._stringData = value;
                this.NotifyPropertyChanged("String");
            }
        }

        public DateTime DateTime
        {
            get
            {
                return this._dateTimeData;
            }

            set
            {
                this._dateTimeData = value;
                this.NotifyPropertyChanged("DateTime");
            }
        }

        public DateTime? NDateTime
        {
            get
            {
                return this._nullableDateTimeData;
            }

            set
            {
                this._nullableDateTimeData = value;
                this.NotifyPropertyChanged("NDateTime");
            }
        }

        public Uri Uri
        {
            get
            {
                return this._uriData;
            }

            set
            {
                this._uriData = value;
                this.NotifyPropertyChanged("Uri");
            }
        }

        public ObservableCollection<Data> DataItems
        {
            get
            {
                if (this._dataItems == null)
                {
                    this._dataItems = new ObservableCollection<Data>();
                }

                return this._dataItems;
            }

            private set
            {
                this._dataItems = value;
                this.NotifyPropertyChanged("DataItems");
            }
        }

        #region INotifyPropertyChanged members

        private void NotifyPropertyChanged(string info)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion //INotifyPropertyChanged members
    }
}
