﻿using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Controls.Layouts;


namespace XamDockManagerWithWeb
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.igXamDockManager.PaneClosing += new System.EventHandler<CancellablePaneEventArgs>(igXamDockManager_PaneClosing);

            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            var split = new SplitPane() { Orientation = Orientation.Vertical };
            split.Location = XamDockLocation.Right;
            var cp1 = new ContentPane() { Header = "cp1" };
            var cp2 = new ContentPane() { Header = "cp2" };
            split.Panes.Add(cp1);
            split.Panes.Add(cp2);

            this.igXamDockManager.Panes.Add(split);
        }

        void  igXamDockManager_PaneClosing(object sender, CancellablePaneEventArgs e)
        {
            e.Cancel = true;
            ContentPane cPane = e.Pane as ContentPane;

            if (e.Pane.IsFloating == true)
                e.Pane.IsFloating = false;
            if (cPane != null && cPane.IsPinned == false)
            {
                cPane.IsPinned = true;
            }

            if (this.igXamDockManager.Panes.Contains(e.Pane))
            {
                this.igXamDockManager.Panes.Remove(e.Pane);
                return;
            }
            else
                if (e.Pane.OwnerPane is TabGroupPane)
                    (e.Pane.OwnerPane as TabGroupPane).Panes.Remove(e.Pane as ContentPane);
                else
                    if (e.Pane.OwnerPane is SplitPane)
                        (e.Pane.OwnerPane as SplitPane).Panes.Remove(e.Pane);
        }

    }

}
